> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://walmart.postmansolutions.com/us-marketplace/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://walmart.postmansolutions.com/us-marketplace/_mcp/server.

# Creates an upload destination for the resource given

POST https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/{resource}

Returns a pre-signed URL and upload destination ID for uploading
a document for the given resource (e.g. feeds, reports).
**Do not log the pre-signed URL — it contains temporary credentials.**


Reference: https://walmart.postmansolutions.com/us-marketplace/api-reference/feeds-reports/uploads/create-upload-destination-for-resource

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://marketplace.walmart.com/seller/v1` (Production, default)
- `https://sandbox.marketplace.walmart.com/seller/v1` (Sandbox)

## Request

### Path parameters

- `resource` (enum, required) — The resource type for the upload destination (e.g. feeds)
  - Allowed values: `feeds`, `reports`

### Query parameters

- `contentType` (enum, required) — MIME type of the content to be uploaded
  - Allowed values: `text/xml; charset=UTF-8`, `text/tab-separated-values; charset=UTF-8`, `application/json; charset=UTF-8`, `application/octet-stream`
- `marketplaceIds` (list of enum, required)
  - Allowed values: `WALMART_US`, `WALMART_CA`, `WALMART_MX`

### Headers

- `contentMD5` (string, required) — MD5 hash of the content to be uploaded, encoded as base64

## Response

### 201

Upload destination created

- `uploadDestinationId` (string, optional) — The upload destination ID to pass when creating a feed or report
- `url` (string, optional) — Pre-signed URL for a PUT upload (valid 15 minutes) — do not log
- `headers` (map from string to string, optional) — HTTP headers to include with the upload PUT request

## Errors

### 400 Bad Request Error

Bad Request

- `errors` (list of Error, required)

### 403 Forbidden Error

Forbidden

- `errors` (list of Error, required)

### 429 Too Many Requests Error

Rate limit exceeded

- `errors` (list of Error, required)

### 500 Internal Server Error

Internal Server Error

- `errors` (list of Error, required)

## Types

### Error

- `code` (string, required)
- `message` (string, required)
- `details` (string, optional)

## Examples

**Response**

```json
{
  "uploadDestinationId": "string",
  "url": "string",
  "headers": {}
}
```

**SDK Code**

```python
import requests

url = "https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/feeds"

querystring = {"contentType":"text/xml; charset=UTF-8","marketplaceIds":"WALMART_US"}

headers = {
    "contentMD5": "contentMD5",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/feeds?contentType=text%2Fxml%3B+charset%3DUTF-8&marketplaceIds=WALMART_US';
const options = {
  method: 'POST',
  headers: {contentMD5: 'contentMD5', Authorization: 'Bearer <token>'}
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/feeds?contentType=text%2Fxml%3B+charset%3DUTF-8&marketplaceIds=WALMART_US"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("contentMD5", "contentMD5")
	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/feeds?contentType=text%2Fxml%3B+charset%3DUTF-8&marketplaceIds=WALMART_US")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["contentMD5"] = 'contentMD5'
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/feeds?contentType=text%2Fxml%3B+charset%3DUTF-8&marketplaceIds=WALMART_US")
  .header("contentMD5", "contentMD5")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/feeds?contentType=text%2Fxml%3B+charset%3DUTF-8&marketplaceIds=WALMART_US', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'contentMD5' => 'contentMD5',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/feeds?contentType=text%2Fxml%3B+charset%3DUTF-8&marketplaceIds=WALMART_US");
var request = new RestRequest(Method.POST);
request.AddHeader("contentMD5", "contentMD5");
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "contentMD5": "contentMD5",
  "Authorization": "Bearer <token>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://marketplace.walmart.com/seller/v1/uploads/v4/uploadDestinations/feeds?contentType=text%2Fxml%3B+charset%3DUTF-8&marketplaceIds=WALMART_US")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```